Index: include/multibyte_def.h
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/include/multibyte_def.h	Wed Aug 20 16:00:28 1997
***************
*** 0 ****
--- 1,47 ----
+ #define CS_RAW0 0x80
+ #define CS_RAW1 0x81
+ #define CS_RAW2 0x82
+ #define CS_RAW3 0x83
+ #define CS_RAW4 0x84
+ #define CS_RAW5 0x85
+ #define CS_RAW6 0x86
+ #define CS_RAW7 0x87
+ #define CS_JISX0208_1978 0x88
+ #define CS_GB2312 0x89
+ #define CS_JISX0208_1983 0x8a
+ #define CS_JISX0208_1990 0x8b
+ #define CS_KSC5601 0x8c
+ #define CS_JISX0212_1990 0x8d
+ #define CS_ISO_IR165 0x8e
+ #define CS_CNS11643_1 0x8f
+ #define CS_CNS11643_2 0x90
+ #define CS_CNS11643_3 0x91
+ #define CS_CNS11643_4 0x92
+ #define CS_CNS11643_5 0x93
+ #define CS_CNS11643_6 0x94
+ #define CS_CNS11643_7 0x95
+ #define CS_BIG5_1 0x96
+ #define CS_BIG5_2 0x97
+ #define CS_IRV 0x98
+ #define CS_UK 0x99
+ #define CS_SWEDISH 0x9a
+ #define CS_NORWEGIAN 0x9b
+ #define CS_JISX0201_RIGHT 0x9c
+ #define CS_JISX0201_LEFT 0x9d
+ #define CS_GERMAN 0x9e
+ #define CS_FRENCH 0x9f
+ #define CS_ITALIAN 0xa0
+ #define CS_SPANISH 0xa1
+ #define CS_LATIN1 0xa2
+ #define CS_LATIN2 0xa3
+ #define CS_LATIN3 0xa4
+ #define CS_LATIN4 0xa5
+ #define CS_GREEK 0xa6
+ #define CS_ARABIC 0xa7
+ #define CS_HEBREW 0xa8
+ #define CS_CYRILLIC 0xa9
+ #define CS_LATIN5R 0xaa
+ #define CS_THAI 0xab
+ #define CS_LATIN6 0xac
+ #define CS_LATIN6ADD 0xad
+ #define CS_MAX 0xae
Index: include/options_def.h
*** nvi-1.79/include/options_def.h	Wed Oct 23 22:53:10 1996
--- nvi-1.79-m17n/include/options_def.h	Wed Aug 20 14:47:20 1997
***************
*** 1,79 ****
  #define O_ALTWERASE 0
! #define O_AUTOINDENT 1
! #define O_AUTOPRINT 2
! #define O_AUTOWRITE 3
! #define O_BACKUP 4
! #define O_BEAUTIFY 5
! #define O_CDPATH 6
! #define O_CEDIT 7
! #define O_COLUMNS 8
! #define O_COMMENT 9
! #define O_DIRECTORY 10
! #define O_EDCOMPATIBLE 11
! #define O_ESCAPETIME 12
! #define O_ERRORBELLS 13
! #define O_EXRC 14
! #define O_EXTENDED 15
! #define O_FILEC 16
! #define O_FLASH 17
! #define O_HARDTABS 18
! #define O_ICLOWER 19
! #define O_IGNORECASE 20
! #define O_KEYTIME 21
! #define O_LEFTRIGHT 22
! #define O_LINES 23
! #define O_LISP 24
! #define O_LIST 25
! #define O_LOCKFILES 26
! #define O_MAGIC 27
! #define O_MATCHTIME 28
! #define O_MESG 29
! #define O_MODELINE 30
! #define O_MSGCAT 31
! #define O_NOPRINT 32
! #define O_NUMBER 33
! #define O_OCTAL 34
! #define O_OPEN 35
! #define O_OPTIMIZE 36
! #define O_PARAGRAPHS 37
! #define O_PATH 38
! #define O_PRINT 39
! #define O_PROMPT 40
! #define O_READONLY 41
! #define O_RECDIR 42
! #define O_REDRAW 43
! #define O_REMAP 44
! #define O_REPORT 45
! #define O_RULER 46
! #define O_SCROLL 47
! #define O_SEARCHINCR 48
! #define O_SECTIONS 49
! #define O_SECURE 50
! #define O_SHELL 51
! #define O_SHELLMETA 52
! #define O_SHIFTWIDTH 53
! #define O_SHOWMATCH 54
! #define O_SHOWMODE 55
! #define O_SIDESCROLL 56
! #define O_SLOWOPEN 57
! #define O_SOURCEANY 58
! #define O_TABSTOP 59
! #define O_TAGLENGTH 60
! #define O_TAGS 61
! #define O_TERM 62
! #define O_TERSE 63
! #define O_TILDEOP 64
! #define O_TIMEOUT 65
! #define O_TTYWERASE 66
! #define O_VERBOSE 67
! #define O_W1200 68
! #define O_W300 69
! #define O_W9600 70
! #define O_WARN 71
! #define O_WINDOW 72
! #define O_WINDOWNAME 73
! #define O_WRAPLEN 74
! #define O_WRAPMARGIN 75
! #define O_WRAPSCAN 76
! #define O_WRITEANY 77
! #define O_OPTIONCOUNT 78
--- 1,89 ----
  #define O_ALTWERASE 0
! #define O_AUTODETECT 1
! #define O_AUTOINDENT 2
! #define O_AUTOPRINT 3
! #define O_AUTOWRITE 4
! #define O_BACKUP 5
! #define O_BEAUTIFY 6
! #define O_CANNA 7
! #define O_CANNACTRL 8
! #define O_CANNAKEY 9
! #define O_CANNASERVER 10
! #define O_CDPATH 11
! #define O_CEDIT 12
! #define O_COLUMNS 13
! #define O_COMMENT 14
! #define O_DIRECTORY 15
! #define O_DISPLAYENCODING 16
! #define O_EDCOMPATIBLE 17
! #define O_ESCAPETIME 18
! #define O_ERRORBELLS 19
! #define O_EXRC 20
! #define O_EXTENDED 21
! #define O_FEPKEY 22
! #define O_FILEC 23
! #define O_FILEENCODING 24
! #define O_FLASH 25
! #define O_HARDTABS 26
! #define O_ICLOWER 27
! #define O_IGNORECASE 28
! #define O_INPUTENCODING 29
! #define O_KEYTIME 30
! #define O_LEFTRIGHT 31
! #define O_LINES 32
! #define O_LISP 33
! #define O_LIST 34
! #define O_LOCKFILES 35
! #define O_MAGIC 36
! #define O_MATCHTIME 37
! #define O_MESG 38
! #define O_MODELINE 39
! #define O_MSGCAT 40
! #define O_NOPRINT 41
! #define O_NUMBER 42
! #define O_OCTAL 43
! #define O_OPEN 44
! #define O_OPTIMIZE 45
! #define O_PARAGRAPHS 46
! #define O_PATH 47
! #define O_PRINT 48
! #define O_PROMPT 49
! #define O_READONLY 50
! #define O_RECDIR 51
! #define O_REDRAW 52
! #define O_REMAP 53
! #define O_REPORT 54
! #define O_RULER 55
! #define O_SCROLL 56
! #define O_SEARCHINCR 57
! #define O_SECTIONS 58
! #define O_SECURE 59
! #define O_SHELL 60
! #define O_SHELLMETA 61
! #define O_SHIFTWIDTH 62
! #define O_SHOWMATCH 63
! #define O_SHOWMODE 64
! #define O_SIDESCROLL 65
! #define O_SKIPDISPLAY 66
! #define O_SLOWOPEN 67
! #define O_SOURCEANY 68
! #define O_TABSTOP 69
! #define O_TAGLENGTH 70
! #define O_TAGS 71
! #define O_TERM 72
! #define O_TERSE 73
! #define O_TILDEOP 74
! #define O_TIMEOUT 75
! #define O_TTYWERASE 76
! #define O_VERBOSE 77
! #define O_W1200 78
! #define O_W300 79
! #define O_W9600 80
! #define O_WARN 81
! #define O_WINDOW 82
! #define O_WINDOWNAME 83
! #define O_WRAPLEN 84
! #define O_WRAPMARGIN 85
! #define O_WRAPSCAN 86
! #define O_WRITEANY 87
! #define O_OPTIONCOUNT 88
Index: include/vi_extern.h
*** nvi-1.79/include/vi_extern.h	Wed Oct 23 22:53:12 1996
--- nvi-1.79-m17n/include/vi_extern.h	Wed Aug 20 14:47:21 1997
***************
*** 1,8 ****
--- 1,14 ----
  int cs_init __P((SCR *, VCS *));
  int cs_next __P((SCR *, VCS *));
+ #ifdef MULTIBYTE
+ int cs_multi_next __P((SCR *, VCS *));
+ #endif
  int cs_fspace __P((SCR *, VCS *));
  int cs_fblank __P((SCR *, VCS *));
  int cs_prev __P((SCR *, VCS *));
+ #ifdef MULTIBYTE
+ int cs_multi_prev __P((SCR *, VCS *));
+ #endif
  int cs_bblank __P((SCR *, VCS *));
  int v_at __P((SCR *, VICMD *));
  int v_chrepeat __P((SCR *, VICMD *));
***************
*** 94,100 ****
--- 100,110 ----
  void v_nomove __P((SCR *));
  void v_sof __P((SCR *, MARK *));
  void v_sol __P((SCR *));
+ #ifndef MULTIBYTE
  int v_isempty __P((char *, size_t));
+ #else
+ int v_isempty __P((CHAR_T *, size_t));
+ #endif
  void v_emsg __P((SCR *, char *, vim_t));
  int v_wordW __P((SCR *, VICMD *));
  int v_wordw __P((SCR *, VICMD *));
***************
*** 114,124 ****
--- 124,141 ----
  void vs_busy __P((SCR *, const char *, busy_t));
  void vs_home __P((SCR *));
  void vs_update __P((SCR *, const char *, const char *));
+ #ifndef MULTIBYTE
  void vs_msg __P((SCR *, mtype_t, char *, size_t));
+ #else
+ void vs_msg __P((SCR *, mtype_t, CHAR_T *, size_t));
+ #endif
  int vs_ex_resolve __P((SCR *, int *));
  int vs_resolve __P((SCR *, SCR *, int));
  int vs_repaint __P((SCR *, EVENT *));
  int vs_refresh __P((SCR *, int));
+ #ifdef CANNA
+ void vs_modeline __P((SCR *));
+ #endif
  int vs_column __P((SCR *, size_t *));
  size_t vs_screens __P((SCR *, recno_t, size_t *));
  size_t vs_columns __P((SCR *, char *, recno_t, size_t *, size_t *));
Index: regex/README.m17n
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/regex/README.m17n	Sun Feb 16 00:00:33 1997
***************
*** 0 ****
--- 1,21 ----
+ notes on regex multilingual patch
+ Jun-ichiro itojun Itoh <itojun@mt.cs.keio.ac.jp>
+ $Id: README.m17n,v 1.3 1997/02/15 15:00:32 itojun Exp $
+ 
+ 	The patched regex routine contained in this directory understands
+ 	multilingual encoding method used by nvi-m17n.
+ 
+ 	operations known to work for multibyte chars:
+ 	- almost everything
+ 	  Please note that, you can't mix characters in different character
+ 	  set in single range specification.
+ 	  For example, suppose A and Z are in JIS X0208-1983, and a and z are 
+ 	  in ASCII:
+ 		[AZaz]		ok
+ 		[A-Za-z]	ok
+ 		[A-z]		bad
+ 		[a-Z]		bad
+ 
+ 	operations known to be safe over multibyte chars, but has no effect
+ 	to multibyte chars:
+ 	- word boundary([[:<:]] and [[:>:]])
Index: regex/regcomp.c
Prereq: 	8.4 
*** nvi-1.79/regex/regcomp.c	Sun Mar 20 01:21:28 1994
--- nvi-1.79-m17n/regex/regcomp.c	Thu Apr 10 12:29:49 1997
***************
*** 94,99 ****
--- 94,102 ----
  static char othercase __P((int ch));
  static void bothcases __P((struct parse *p, int ch));
  static void ordinary __P((struct parse *p, int ch));
+ #ifdef MULTIBYTE
+ static void mordinary __P((struct parse *p, int ch));
+ #endif
  static void nonnewline __P((struct parse *p));
  static void repeat __P((struct parse *p, sopno start, int from, int to));
  static int seterr __P((struct parse *p, int e));
***************
*** 400,412 ****
--- 403,423 ----
  	case '\\':
  		REQUIRE(MORE(), REG_EESCAPE);
  		c = GETNEXT();
+ #ifndef MULTIBYTE
  		ordinary(p, c);
+ #else
+ 		mordinary(p, c);
+ #endif
  		break;
  	case '{':		/* okay as ordinary except if digit follows */
  		REQUIRE(!MORE() || !isdigit(PEEK()), REG_BADRPT);
  		/* FALLTHROUGH */
  	default:
+ #ifndef MULTIBYTE
  		ordinary(p, c);
+ #else
+ 		mordinary(p, c);
+ #endif
  		break;
  	}
  
***************
*** 479,486 ****
  register struct parse *p;
  {
  	REQUIRE(MORE(), REG_EMPTY);
! 	while (MORE())
  		ordinary(p, GETNEXT());
  }
  
  /*
--- 490,502 ----
  register struct parse *p;
  {
  	REQUIRE(MORE(), REG_EMPTY);
! 	while (MORE()) {
! #ifndef MULTIBYTE
  		ordinary(p, GETNEXT());
+ #else
+ 		mordinary(p, GETNEXT());
+ #endif
+ 	}
  }
  
  /*
***************
*** 609,615 ****
--- 625,635 ----
  		REQUIRE(starordinary, REG_BADRPT);
  		/* FALLTHROUGH */
  	default:
+ #ifndef MULTIBYTE
  		ordinary(p, c &~ BACKSL);
+ #else
+ 		mordinary(p, c &~ BACKSL);
+ #endif
  		break;
  	}
  
***************
*** 731,737 ****
--- 751,759 ----
  			mcinvert(p, cs);
  	}
  
+ #ifndef MULTIBYTE
  	assert(cs->multis == NULL);		/* xxx */
+ #endif
  
  	if (nch(p, cs) == 1) {		/* optimize singleton sets */
  		ordinary(p, firstch(p, cs));
***************
*** 787,794 ****
--- 809,880 ----
  		REQUIRE(EATTWO('=', ']'), REG_ECOLLATE);
  		break;
  	default:		/* symbol, ordinary character, or range */
+ #ifndef MULTIBYTE
  /* xxx revision needed for multichar stuff */
+ #else
+ 		/*
+ 		 * multibyte case.
+ 		 */
+ 		if (1 < multi_byte_c(NULL, PEEK())) {
+ 			u_char charset;
+ 			size_t siz;
+ 			size_t i;
+ 			char *pstart;
+ 			char *pfinish;
+ 			char *ptmp;
+ 
+ 			charset = PEEK() & 0xff;
+ 			siz = multi_byte_c(NULL, charset);
+ 			pstart = (char *)malloc(siz + 1);
+ 			pfinish = (char *)malloc(siz + 1);
+ 			ptmp = (char *)malloc(siz * 2 + 1);
+ 
+ 			memcpy(pstart, p->next, siz);
+ 			pstart[siz] = '\0';
+ 			NEXTn(siz);
+ 			if (SEE('-') && (p->next + siz < p->end)) {
+ 				NEXT();
+ 				if ((PEEK() & 0xff) == charset) {
+ 					memcpy(pfinish, p->next, siz);
+ 					pfinish[siz] = '\0';
+ 					NEXTn(siz);
+ 				} else
+ 					SETERROR(REG_ERANGE);
+ 			} else {
+ 				memcpy(pfinish, pstart, siz + 1);
+ 				pfinish[siz] = '\0';
+ 			}
+ 
+ 			for (i = 1; i < siz; i++) {
+ 				if ((u_char)pstart[i] < (u_char)pfinish[i])
+ 					break;
+ 				else if ((u_char)pstart[i] > (u_char)pfinish[i])
+ 					SETERROR(REG_ERANGE);
+ 			}
+ 
+ 			strcpy(ptmp, pstart);
+ 			strcat(ptmp, pfinish);
+ 			MCadd(p, cs, ptmp);
+ 
+ 			free(pstart);
+ 			free(pfinish);
+ 			free(ptmp);
+ 			
+ 			break;
+ 		}
+ 
+ 		/*
+ 		 * singlebyte case.
+ 		 */
+ 		/* just to make sure */
+ 		if (1 < multi_byte_c(NULL, PEEK()))
+ 			SETERROR(REG_ERANGE);
+ #endif /*MULTIBYTE*/
  		start = p_b_symbol(p);
+ #ifdef MULTIBYTE
+ 		if (1 < multi_byte_c(NULL, PEEK2()))
+ 			SETERROR(REG_ERANGE);
+ #endif /*MULTIBYTE*/
  		if (SEE('-') && MORE2() && PEEK2() != ']') {
  			/* range */
  			NEXT();
***************
*** 971,976 ****
--- 1057,1105 ----
  	}
  }
  
+ #ifdef MULTIBYTE
+ /*
+  - ordinary - emit an ordinary character
+  == static void mordinary(register struct parse *p, register int ch);
+  */
+ static void
+ mordinary(p, ch)
+ register struct parse *p;
+ register int ch;
+ {
+ 	register cat_t *cap = p->g->categories;
+ 	size_t advance;
+ 	extern int multi_byte_c __P((void *, u_int));	/*XXX*/
+ 
+ 	advance = multi_byte_c(NULL, ch);		/*XXX*/
+ 	if (advance == 1) {
+ 		ordinary(p, ch);
+ 		return;
+ 	}
+ 
+ 	/* multibyte case. */
+ 	p->next--;
+ 	REQUIRE(p->next + advance - 1 < p->end, REG_INVARG);	/*XXX*/
+ 	switch (advance) {
+ 	case 2:
+ 		ch = ((u_int)p->next[0] & 0xff) << 8;
+ 		ch |= ((u_int)p->next[1] & 0xff);
+ 		EMIT(OCHAR2, ch); 
+ 		NEXTn(2);
+ 		break;
+ 	case 3:
+ 		ch = ((u_int)p->next[0] & 0xff) << 16;
+ 		ch |= ((u_int)p->next[1] & 0xff) << 8;
+ 		ch |= p->next[2] & 0xff;
+ 		EMIT(OCHAR3, ch); 
+ 		NEXTn(3);
+ 		break;
+ 	default:
+ 		abort();
+ 	}
+ }
+ #endif
+ 
  /*
   - nonnewline - emit REG_NEWLINE version of OANY
   == static void nonnewline(register struct parse *p);
***************
*** 1136,1141 ****
--- 1265,1273 ----
  	cs->hash = 0;
  	cs->smultis = 0;
  	cs->multis = NULL;
+ #ifdef MULTIBYTE
+ 	cs->multiinvert = 0;
+ #endif
  
  	return(cs);
  }
***************
*** 1260,1266 ****
  		return;
  	}
  
! 	(void) strcpy(cs->multis + oldend - 1, cp);
  	cs->multis[cs->smultis - 1] = '\0';
  }
  
--- 1392,1398 ----
  		return;
  	}
  
! 	(void) strcpy(cs->multis + oldend, cp);
  	cs->multis[cs->smultis - 1] = '\0';
  }
  
***************
*** 1334,1340 ****
--- 1466,1476 ----
  register struct parse *p;
  register cset *cs;
  {
+ #ifndef MULTIBYTE
  	assert(cs->multis == NULL);	/* xxx */
+ #else
+ 	cs->multiinvert = cs->multiinvert ? 0 : 1;
+ #endif
  }
  
  /*
***************
*** 1349,1355 ****
--- 1485,1493 ----
  register struct parse *p;
  register cset *cs;
  {
+ #ifndef MULTIBYTE
  	assert(cs->multis == NULL);	/* xxx */
+ #endif
  }
  
  /*
Index: regex/regex2.h
Prereq: 	8.3 
*** nvi-1.79/regex/regex2.h	Wed Jul 10 08:05:31 1996
--- nvi-1.79-m17n/regex/regex2.h	Thu Jan  2 09:54:39 1997
***************
*** 105,110 ****
--- 105,112 ----
  #define	O_CH	(18<<OPSHIFT)	/* end choice	back to OOR1		*/
  #define	OBOW	(19<<OPSHIFT)	/* begin word	-			*/
  #define	OEOW	(20<<OPSHIFT)	/* end word	-			*/
+ #define	OCHAR2	(21<<OPSHIFT)	/* character	(ch1<<8) | ch2		*/
+ #define	OCHAR3	(22<<OPSHIFT)	/* character	(ch1<<16)|(ch2<<8)|ch3	*/
  
  /*
   * Structure for [] character-set representation.  Character sets are
***************
*** 124,129 ****
--- 126,132 ----
  	uch hash;		/* hash code */
  	size_t smultis;
  	char *multis;		/* -> char[smulti]  ab\0cd\0ef\0\0 */
+ 	char multiinvert;
  } cset;
  /* note that CHadd and CHsub are unsafe, and CHIN doesn't yield 0/1 */
  #define	CHadd(cs, c)	((cs)->ptr[(uch)(c)] |= (cs)->mask, (cs)->hash += (c))
Index: vi/getc.c
Prereq: 	10.10 
*** nvi-1.79/vi/getc.c	Sun Apr 28 00:20:32 1996
--- nvi-1.79-m17n/vi/getc.c	Fri Feb 21 22:40:32 1997
***************
*** 77,82 ****
--- 77,87 ----
  {
  	char *p;
  
+ #ifndef MULTIBYTE
+ 	/* it is illegal to use this function */
+ 	abort();
+ #endif /*MULTIBYTE*/
+ 
  	switch (csp->cs_flags) {
  	case CS_EMP:				/* EMP; get next line. */
  	case CS_EOL:				/* EOL; get next line. */
***************
*** 110,115 ****
--- 115,177 ----
  	return (0);
  }
  
+ #ifdef MULTIBYTE
+ /*
+  * cs_multi_next --
+  *	Retrieve the next character, with consideration to multibyte chars.
+  *	It returns the first byte of multibyte char only.  You will need to
+  *	retrieve rest of it by using cs_next().
+  *	It is assumed that csp->cs_cno designates the first byte of
+  *	multibyte char.
+  *
+  * PUBLIC: #ifdef MULTIBYTE
+  * PUBLIC: int cs_multi_next __P((SCR *, VCS *));
+  * PUBLIC: #endif
+  */
+ int
+ cs_multi_next(sp, csp)
+ 	SCR *sp;
+ 	VCS *csp;
+ {
+ 	char *p;
+ 
+ 	switch (csp->cs_flags) {
+ 	case CS_EMP:				/* EMP; get next line. */
+ 	case CS_EOL:				/* EOL; get next line. */
+ 		if (db_get(sp, ++csp->cs_lno, 0, &p, &csp->cs_len)) {
+ 			--csp->cs_lno;
+ 			csp->cs_flags = CS_EOF;
+ 		} else {
+ 			csp->cs_bp = p;
+ 			if (csp->cs_len == 0 ||
+ 			    v_isempty(csp->cs_bp, csp->cs_len)) {
+ 				csp->cs_cno = 0;
+ 				csp->cs_flags = CS_EMP;
+ 			} else {
+ 				csp->cs_flags = 0;
+ 				csp->cs_ch = csp->cs_bp[csp->cs_cno = 0];
+ 			}
+ 		}
+ 		break;
+ 	case 0:
+ 		if (csp->cs_len <=
+ 		    csp->cs_cno + KEY_BLEN(sp, csp->cs_bp[csp->cs_cno]))
+ 			csp->cs_flags = CS_EOL;
+ 		else {
+ 			csp->cs_cno += KEY_BLEN(sp, csp->cs_bp[csp->cs_cno]);
+ 			csp->cs_ch = csp->cs_bp[csp->cs_cno];
+ 		}
+ 		break;
+ 	case CS_EOF:				/* EOF. */
+ 		break;
+ 	default:
+ 		abort();
+ 		/* NOTREACHED */
+ 	}
+ 	return (0);
+ }
+ #endif /*MULTIBYTE*/
+ 
  /*
   * cs_fspace --
   *	If on a space, eat forward until something other than a
***************
*** 130,136 ****
--- 192,202 ----
  	if (csp->cs_flags != 0 || !isblank(csp->cs_ch))
  		return (0);
  	for (;;) {
+ #ifndef MULTIBYTE
  		if (cs_next(sp, csp))
+ #else
+ 		if (cs_multi_next(sp, csp))
+ #endif
  			return (1);
  		if (csp->cs_flags != 0 || !isblank(csp->cs_ch))
  			break;
***************
*** 150,156 ****
--- 216,226 ----
  	VCS *csp;
  {
  	for (;;) {
+ #ifndef MULTIBYTE
  		if (cs_next(sp, csp))
+ #else
+ 		if (cs_multi_next(sp, csp))
+ #endif
  			return (1);
  		if (csp->cs_flags == CS_EOL || csp->cs_flags == CS_EMP ||
  		    csp->cs_flags == 0 && isblank(csp->cs_ch))
***************
*** 171,176 ****
--- 241,251 ----
  	SCR *sp;
  	VCS *csp;
  {
+ #ifndef MULTIBYTE
+ 	/* it is illegal to use this function. */
+ 	abort();
+ #endif /*MULTIBYTE*/
+ 
  	switch (csp->cs_flags) {
  	case CS_EMP:				/* EMP; get previous line. */
  	case CS_EOL:				/* EOL; get previous line. */
***************
*** 211,216 ****
--- 286,353 ----
  	return (0);
  }
  
+ #ifdef MULTIBYTE
+ /*
+  * cs_multi_prev --
+  *	Retrieve the previous character, with consideration to multibyte chars.
+  *	It returns the first byte of multibyte char only.  You will need to
+  *	retrieve rest of it by using cs_next().
+  *	It is assumed that csp->cs_cno designates the first byte of
+  *	multibyte char.
+  *
+  * PUBLIC: #ifdef MULTIBYTE
+  * PUBLIC: int cs_multi_prev __P((SCR *, VCS *));
+  * PUBLIC: #endif
+  */
+ int
+ cs_multi_prev(sp, csp)
+ 	SCR *sp;
+ 	VCS *csp;
+ {
+ 	switch (csp->cs_flags) {
+ 	case CS_EMP:				/* EMP; get previous line. */
+ 	case CS_EOL:				/* EOL; get previous line. */
+ 		if (csp->cs_lno == 1) {		/* SOF. */
+ 			csp->cs_flags = CS_SOF;
+ 			break;
+ 		}
+ 		if (db_get(sp,			/* The line should exist. */
+ 		    --csp->cs_lno, DBG_FATAL, &csp->cs_bp, &csp->cs_len)) {
+ 			++csp->cs_lno;
+ 			return (1);
+ 		}
+ 		if (csp->cs_len == 0 || v_isempty(csp->cs_bp, csp->cs_len)) {
+ 			csp->cs_cno = 0;
+ 			csp->cs_flags = CS_EMP;
+ 		} else {
+ 			csp->cs_flags = 0;
+ 			csp->cs_cno = csp->cs_len;
+ 			csp->cs_cno -= multi_back(sp, csp->cs_bp, &csp->cs_bp[csp->cs_len]);
+ 			csp->cs_ch = csp->cs_bp[csp->cs_cno];
+ 		}
+ 		break;
+ 	case CS_EOF:				/* EOF: get previous char. */
+ 	case 0:
+ 		if (csp->cs_cno == 0)
+ 			if (csp->cs_lno == 1)
+ 				csp->cs_flags = CS_SOF;
+ 			else
+ 				csp->cs_flags = CS_EOL;
+ 		else {
+ 			csp->cs_cno -= multi_back(sp, csp->cs_bp, &csp->cs_bp[csp->cs_cno]);
+ 			csp->cs_ch = csp->cs_bp[csp->cs_cno];
+ 		}
+ 		break;
+ 	case CS_SOF:				/* SOF. */
+ 		break;
+ 	default:
+ 		abort();
+ 		/* NOTREACHED */
+ 	}
+ 	return (0);
+ }
+ #endif /*MULTIBYTE*/
+ 
  /*
   * cs_bblank --
   *	Eat backward to the next non-whitespace character.
***************
*** 223,229 ****
--- 360,370 ----
  	VCS *csp;
  {
  	for (;;) {
+ #ifndef MULTIBYTE
  		if (cs_prev(sp, csp))
+ #else
+ 		if (cs_multi_prev(sp, csp))
+ #endif
  			return (1);
  		if (csp->cs_flags == CS_EOL || csp->cs_flags == CS_EMP ||
  		    csp->cs_flags == 0 && isblank(csp->cs_ch))
Index: vi/v_ch.c
Prereq: 	10.8 
*** nvi-1.79/vi/v_ch.c	Sun Apr 28 00:20:32 1996
--- nvi-1.79-m17n/vi/v_ch.c	Sun Feb  2 15:48:33 1997
***************
*** 25,31 ****
--- 25,35 ----
  #include "../common/common.h"
  #include "vi.h"
  
+ #ifndef MULTIBYTE
  static void notfound __P((SCR *, ARG_CHAR_T));
+ #else
+ static void notfound __P((SCR *, CHAR_T *));
+ #endif
  static void noprev __P((SCR *));
  
  /*
***************
*** 39,45 ****
--- 43,53 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifndef MULTIBYTE
  	vp->character = VIP(sp)->lastckey;
+ #else
+ 	memcpy(vp->characters, VIP(sp)->lastckeys, sizeof(vp->characters));
+ #endif
  
  	switch (VIP(sp)->csearchdir) {
  	case CNOTSET:
***************
*** 73,79 ****
--- 81,91 ----
  	cdir_t savedir;
  	int rval;
  
+ #ifndef MULTIBYTE
  	vp->character = VIP(sp)->lastckey;
+ #else
+ 	memcpy(vp->characters, VIP(sp)->lastckeys, sizeof(vp->characters));
+ #endif
  	savedir = VIP(sp)->csearchdir;
  
  	switch (VIP(sp)->csearchdir) {
***************
*** 111,125 ****
--- 123,151 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
+ 
  	if (v_chf(sp, vp))
  		return (1);
  
+ #ifdef MULTIBYTE
+ 	/* we need content of the line. */
+ 	if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 		return (1);
+ #endif
+ 
  	/*
  	 * v_chf places the cursor on the character, where the 't'
  	 * command wants it to its left.  We know this is safe since
  	 * we had to move right for v_chf() to have succeeded.
  	 */
+ #ifndef MULTIBYTE
  	--vp->m_stop.cno;
+ #else
+ 	vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif
  
  	/*
  	 * Make any necessary correction to the motion decision made
***************
*** 146,162 ****
--- 172,202 ----
  {
  	size_t len;
  	u_long cnt;
+ #ifndef MULTIBYTE
  	int isempty, key;
  	char *endp, *p, *startp;
+ #else
+ 	int isempty;
+ 	CHAR_T *key;
+ 	size_t blen;
+ 	CHAR_T *endp, *p, *startp;
+ #endif /*MULTIBYTE*/
  
  	/*
  	 * !!!
  	 * If it's a dot command, it doesn't reset the key for which we're
  	 * searching, e.g. in "df1|f2|.|;", the ';' searches for a '2'.
  	 */
+ #ifndef MULTIBYTE
  	key = vp->character;
  	if (!F_ISSET(vp, VC_ISDOT))
  		VIP(sp)->lastckey = key;
+ #else
+ 	key = vp->characters;
+ 	blen = KEY_BLEN(sp, key[0]);
+ 	if (!F_ISSET(vp, VC_ISDOT))
+ 		memcpy(VIP(sp)->lastckeys, key, sizeof(VIP(sp)->lastckeys));
+ #endif /*MULTIBYTE*/
  	VIP(sp)->csearchdir = fSEARCH;
  
  	if (db_eget(sp, vp->m_start.lno, &p, &len, &isempty)) {
***************
*** 173,179 ****
--- 213,225 ----
  	endp = (startp = p) + len;
  	p += vp->m_start.cno;
  	for (cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1; cnt--;) {
+ #ifndef MULTIBYTE
  		while (++p < endp && *p != key);
+ #else
+ 		do {
+ 			p += KEY_BLEN(sp, p[0]);
+ 		} while (p < endp && (*p != key[0] || memcmp(p, key, blen)));
+ #endif /*MULTIBYTE*/
  		if (p == endp) {
  			notfound(sp, key);
  			return (1);
***************
*** 202,216 ****
--- 248,276 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
+ 
  	if (v_chF(sp, vp))
  		return (1);
  
+ #ifdef MULTIBYTE
+ 	/* we need content of the line. */
+ 	if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 		return (1);
+ #endif
+ 
  	/*
  	 * v_chF places the cursor on the character, where the 'T'
  	 * command wants it to its right.  We know this is safe since
  	 * we had to move left for v_chF() to have succeeded.
  	 */
+ #ifndef MULTIBYTE
  	++vp->m_stop.cno;
+ #else
+ 	vp->m_stop.cno += KEY_BLEN(sp, p[vp->m_stop.cno]);
+ #endif
  	vp->m_final = vp->m_stop;
  
  	VIP(sp)->csearchdir = TSEARCH;
***************
*** 231,238 ****
--- 291,305 ----
  {
  	size_t len;
  	u_long cnt;
+ #ifndef MULTIBYTE
  	int isempty, key;
  	char *endp, *p;
+ #else
+ 	int isempty;
+ 	CHAR_T *key;
+ 	size_t blen;
+ 	CHAR_T *endp, *p;
+ #endif
  
  	/*
  	 * !!!
***************
*** 240,248 ****
--- 307,322 ----
  	 * we're searching, e.g. in "df1|f2|.|;", the ';' searches
  	 * for a '2'.
  	 */
+ #ifndef MULTIBYTE
  	key = vp->character;
  	if (!F_ISSET(vp, VC_ISDOT))
  		VIP(sp)->lastckey = key;
+ #else
+ 	key = vp->characters;
+ 	blen = KEY_BLEN(sp, key[0]);
+ 	if (!F_ISSET(vp, VC_ISDOT))
+ 		memcpy(VIP(sp)->lastckeys, key, sizeof(VIP(sp)->lastckeys));
+ #endif /*MULTIBYTE*/
  	VIP(sp)->csearchdir = FSEARCH;
  
  	if (db_eget(sp, vp->m_start.lno, &p, &len, &isempty)) {
***************
*** 259,265 ****
--- 333,345 ----
  	endp = p - 1;
  	p += vp->m_start.cno;
  	for (cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1; cnt--;) {
+ #ifndef MULTIBYTE
  		while (--p > endp && *p != key);
+ #else
+ 		do {
+ 			p -= multi_back(sp, endp + 1, p);
+ 		} while (p > endp && (*p != key[0] || memcmp(p, key, blen)));
+ #endif
  		if (p == endp) {
  			notfound(sp, key);
  			return (1);
***************
*** 274,281 ****
  	 * one.
  	 */
  	vp->m_final = vp->m_stop;
! 	if (ISMOTION(vp))
  		--vp->m_start.cno;
  	return (0);
  }
  
--- 354,366 ----
  	 * one.
  	 */
  	vp->m_final = vp->m_stop;
! 	if (ISMOTION(vp)) {
! #ifndef MULTIBYTE
  		--vp->m_start.cno;
+ #else
+ 		vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif
+ 	}
  	return (0);
  }
  
***************
*** 286,291 ****
--- 371,377 ----
  	msgq(sp, M_BERR, "178|No previous F, f, T or t search");
  }
  
+ #ifndef MULTIBYTE
  static void
  notfound(sp, ch)
  	SCR *sp;
***************
*** 293,295 ****
--- 379,400 ----
  {
  	msgq(sp, M_BERR, "179|%s not found", KEY_NAME(sp, ch));
  }
+ #else
+ static void
+ notfound(sp, p)
+ 	SCR *sp;
+ 	CHAR_T *p;
+ {
+ #if 0
+ 	msgq(sp, M_BERR, "179|%s not found", multi_name(sp, p));
+ #else
+ 	/*
+ 	 * currently msg routines do not support multibyte chars.
+ 	 */
+ 	if (1 < KEY_BLEN(sp, p[0]))
+ 		msgq(sp, M_BERR, "179|%s not found", "character");
+ 	else
+ 		msgq(sp, M_BERR, "179|%s not found", KEY_NAME(sp, p));
+ #endif
+ }
+ #endif /*MULTIBYTE*/
Index: vi/v_delete.c
Prereq: 	10.9 
*** nvi-1.79/vi/v_delete.c	Wed Oct 23 22:31:41 1996
--- nvi-1.79-m17n/vi/v_delete.c	Mon Nov 25 00:51:19 1996
***************
*** 90,97 ****
  		F_SET(vp, VM_RCM_SET);
  
  		/* Make sure the set cursor position exists. */
! 		if (vp->m_final.cno >= len)
  			vp->m_final.cno = len ? len - 1 : 0;
  	}
  
  	/*
--- 90,111 ----
  		F_SET(vp, VM_RCM_SET);
  
  		/* Make sure the set cursor position exists. */
! 		if (vp->m_final.cno >= len) {
! #ifndef MULTIBYTE
  			vp->m_final.cno = len ? len - 1 : 0;
+ #else
+ 			CHAR_T *p;
+ 
+ 			/* we need content of the line. */
+ 			if (db_get(sp, vp->m_final.lno, 0, &p, NULL))
+ 				return 1;
+ 
+ 			if (len)
+ 				vp->m_final.cno = len - multi_back(sp, p, &p[len]);
+ 			else
+ 				vp->m_final.cno = 0;
+ #endif /*MULTIBYTE*/
+ 		}
  	}
  
  	/*
Index: vi/v_ex.c
Prereq: 	10.42 
*** nvi-1.79/vi/v_ex.c	Mon Sep 16 05:03:02 1996
--- nvi-1.79-m17n/vi/v_ex.c	Fri Mar 28 00:30:29 1997
***************
*** 506,511 ****
--- 506,514 ----
  	VICMD *vp;
  {
  	size_t len;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
  
  	/*
  	 * The only cursor modifications are real, however, the underlying
***************
*** 521,531 ****
  	 * Ex will soon have to start handling the column correctly; see
  	 * the POSIX 1003.2 standard.
  	 */
! 	if (db_eget(sp, sp->lno, NULL, &len, NULL)) {
  		sp->lno = 1;
  		sp->cno = 0;
! 	} else if (sp->cno >= len)
  		sp->cno = len ? len - 1 : 0;
  
  	vp->m_final.lno = sp->lno;
  	vp->m_final.cno = sp->cno;
--- 524,544 ----
  	 * Ex will soon have to start handling the column correctly; see
  	 * the POSIX 1003.2 standard.
  	 */
! #ifndef MULTIBYTE
! 	if (db_eget(sp, sp->lno, NULL, &len, NULL))
! #else
! 	if (db_eget(sp, sp->lno, &p, &len, NULL))
! #endif
! 	{
  		sp->lno = 1;
  		sp->cno = 0;
! 	} else if (sp->cno >= len) {
! #ifndef MULTIBYTE
  		sp->cno = len ? len - 1 : 0;
+ #else
+ 		sp->cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif
+ 	}
  
  	vp->m_final.lno = sp->lno;
  	vp->m_final.cno = sp->cno;
Index: vi/v_increment.c
Prereq: 	10.12 
*** nvi-1.79/vi/v_increment.c	Sun Apr 28 00:20:33 1996
--- nvi-1.79-m17n/vi/v_increment.c	Thu Feb 20 00:03:46 1997
***************
*** 59,65 ****
--- 59,70 ----
  	long change, ltmp, lval;
  	size_t beg, blen, end, len, nlen, wlen;
  	int base, isempty, rval;
+ #ifndef MULTIBYTE
  	char *bp, *ntype, *p, *t, nbuf[100];
+ #else
+ 	char *bp, *ntype, *t, nbuf[100];
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	/* Validate the operator. */
  	if (vp->character == '#')
Index: vi/v_init.c
Prereq: 	10.8 
*** nvi-1.79/vi/v_init.c	Fri May 17 09:09:04 1996
--- nvi-1.79-m17n/vi/v_init.c	Thu Feb 20 12:40:31 1997
***************
*** 63,69 ****
--- 63,74 ----
  		    v_strdup(sp, ovip->ps, strlen(ovip->ps))) == NULL)
  			return (1);
  
+ #ifndef MULTIBYTE
  		nvip->lastckey = ovip->lastckey;
+ #else
+ 		memcpy(nvip->lastckeys, ovip->lastckeys,
+ 			sizeof(nvip->lastckeys));
+ #endif
  		nvip->csearchdir = ovip->csearchdir;
  
  		nvip->srows = ovip->srows;
Index: vi/v_itxt.c
Prereq: 	10.16 
*** nvi-1.79/vi/v_itxt.c	Wed Oct 23 22:31:47 1996
--- nvi-1.79-m17n/vi/v_itxt.c	Fri Feb 21 22:13:41 1997
***************
*** 71,79 ****
--- 71,87 ----
  	VICMD *vp;
  {
  	size_t len;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
  
+ #ifndef MULTIBYTE
  	if (!db_get(sp, vp->m_start.lno, 0, NULL, &len))
  		sp->cno = len == 0 ? 0 : len - 1;
+ #else
+ 	if (!db_get(sp, vp->m_start.lno, 0, &p, &len))
+ 		sp->cno = len == 0 ? 0 : len - multi_back(sp, p, &p[len]);
+ #endif /*MULTIBYTE*/
  
  	LOG_CORRECT;
  
***************
*** 95,101 ****
--- 103,113 ----
  	size_t len;
  	u_int32_t flags;
  	int isempty;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	flags = set_txt_std(sp, vp, 0);
  	sp->showmode = SM_APPEND;
***************
*** 108,118 ****
  		len = 0;
  		LF_SET(TXT_APPENDEOL);
  	} else if (len) {
! 		if (len == sp->cno + 1) {
  			sp->cno = len;
  			LF_SET(TXT_APPENDEOL);
! 		} else
  			++sp->cno;
  	} else
  		LF_SET(TXT_APPENDEOL);
  
--- 120,140 ----
  		len = 0;
  		LF_SET(TXT_APPENDEOL);
  	} else if (len) {
! #ifndef MULTIBYTE
! 		if (len == sp->cno + 1)
! #else
! 		if (len == sp->cno + KEY_BLEN(sp, p[sp->cno]))
! #endif
! 		{
  			sp->cno = len;
  			LF_SET(TXT_APPENDEOL);
! 		} else {
! #ifndef MULTIBYTE
  			++sp->cno;
+ #else
+ 			sp->cno += KEY_BLEN(sp, p[sp->cno]);
+ #endif
+ 		}
  	} else
  		LF_SET(TXT_APPENDEOL);
  
***************
*** 422,428 ****
--- 444,454 ----
  		LF_SET(TXT_OVERWRITE | TXT_REPLACE);
  	}
  	vp->m_stop.lno = vp->m_start.lno;
+ #ifndef MULTIBYTE
  	vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 	vp->m_stop.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif
  
  	return (v_txt(sp, vp, &vp->m_stop, p, len,
  	    0, OOBLNO, F_ISSET(vp, VC_C1SET) ? vp->count : 1, flags));
***************
*** 442,448 ****
--- 468,478 ----
  	size_t len;
  	u_int32_t flags;
  	int isempty;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	flags = set_txt_std(sp, vp, 0);
  	sp->showmode = SM_CHANGE;
***************
*** 459,468 ****
--- 489,514 ----
  	}
  
  	vp->m_stop.lno = vp->m_start.lno;
+ #ifndef MULTIBYTE
  	vp->m_stop.cno =
  	    vp->m_start.cno + (F_ISSET(vp, VC_C1SET) ? vp->count - 1 : 0);
  	if (vp->m_stop.cno > len - 1)
  		vp->m_stop.cno = len - 1;
+ #else
+     {
+ 	size_t i;
+ 	vp->m_stop.cno = vp->m_start.cno;
+ 	if (F_ISSET(vp, VC_C1SET)) {
+ 		i = 0;
+ 		while (vp->m_stop.cno < len && i < vp->count - 1) {
+ 			vp->m_stop.cno += KEY_BLEN(sp, p[vp->m_stop.cno]);
+ 			i++;
+ 		}
+ 	}
+     }
+ 	if (vp->m_stop.cno > len - multi_back(sp, p, &p[len]))
+ 		vp->m_stop.cno = len - multi_back(sp, p, &p[len]);
+ #endif /*MULTIBYTE*/
  
  	if (p != NULL && cut(sp,
  	    F_ISSET(vp, VC_BUFFER) ? &vp->buffer : NULL,
